//******************************************************************************
//! @file $RCSfile: can_isp_protocol.c,v $
//!
//! Copyright (c) 2009 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txtǂłB
//!
//! @brief ̧قAT90CAN128/64/32ATmega16M1/32M1/32C1/64M1/64C1pɗp
//!		   \CAN ISPKٰ݂܂݂܂B
//!
//! ̧وȉŊmFĂ܂B
//! - AVRStudio 4.15.623,
//! - IAR AVRpC/C++߲ 5.20.1 (5.20.1.50092)
//!
//! @version $Revision: 3.00 $ $Name: jtellier $
//!
//! @todo
//! @bug
//******************************************************************************

//_____ ݸٰ ________________________________________________________________
#include "config.h"
#include "can_isp_protocol.h"
#include "isp_lib.h"
#include "reduced_can_lib.h"
#include "can_drv.h"

//_____ ` ___________________________________________________________________

//_____ 錾 ___________________________________________________________________

U16          base_isp_id;
U8           can_isp_rx_buffer[8];
st_cmd_t     can_isp_rx_msg;
U8           can_isp_tx_buffer[8];
st_cmd_t     can_isp_tx_msg;

U8           local_buffer[BUFFER_SIZE];
U16          loc_buf_index;

Bool         can_communication_opened;

//_____ ֐ ___________________________________________________________________

//------------------------------------------------------------------------------
//  @fn can_isp_protocol_task
//!
//! ̊֐CAN ISPK܂B
//!
//! @warning	Ȃ
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
//------------------------------------------------------------------------------
void can_isp_protocol_init(void)
{
  isp_select_memory = MEM_DEFAULT;
  isp_select_page   = PAGE_DEFAULT;
  isp_start_address = ADD_DEFAULT;
  isp_number_of_bytes = N_DEFAULT;
  isp_prog_on_going = FALSE;

  base_isp_id = (((U16)CRIS) << 4);
  if(base_isp_id > MAX_BASE_ISP_IAP_ID) base_isp_id = MIN_BASE_ISP_IAP_ID ;

  //- Mް
  can_isp_rx_msg.pt_data = &can_isp_rx_buffer[0];
  loc_buf_index = 0;
  //- Mߏ
  can_isp_rx_msg.msk.std = MAX_BASE_ISP_IAP_ID;
  can_isp_rx_msg.cmd = CMD_RX_DATA_MASKED;

  //- Mް
  can_isp_tx_msg.pt_data = &can_isp_tx_buffer[0];
  //- Mߏ
  can_isp_tx_msg.cmd = CMD_TX_DATA;
}

//------------------------------------------------------------------------------
//  @fn can_isp_protocol_task
//!
//! ̊֐CAN ISPKǗ܂B
//!
//! @warning	Ȃ
//!
//! @param	Ȃ
//!
//! @return	0: ޯ ݸނ̍ĕ]v
//!			1: OK(VK߂ɑ΂)
//!
//------------------------------------------------------------------------------
Bool can_isp_protocol_task(void)
{
  U8      i;
  U8      u8_temp;

  //- Mߏ
  can_isp_rx_msg.dlc = 8;							// ő
  can_isp_rx_msg.id.std = base_isp_id;

  //- M(Ɏ󂯓!!!)
  can_cmd(&can_isp_rx_msg);
  //- Mҋ@
  while (1)
  {
	u8_temp = can_get_status(&can_isp_rx_msg);
	if (u8_temp != CAN_STATUS_NOT_COMPLETED) break;	// while(1...o
  }
  if (u8_temp == CAN_STATUS_ERROR)
  {
	return(0);										// ޯ ݸނ̍ĕ]vA֐o
  }

//--- MCAN ISPvɏ]Đ؂ւ
  switch ((can_isp_rx_msg.id.std - base_isp_id))
  {
	//- ʐMJ܂͕(0x00) -------------------------------------
	case CAN_ID_SELECT_NODE:
	  isp_prog_on_going = FALSE;					//- ݒ蒆̎Ԓ߈ُh~u
	  //- ߓ_(ɰ)"ʐMJ"ɉ鎞IAPԂ̏ꍇɍN邽߁A
	  //- Mڰт̒͌KvłB
	  //- Ȃ΁A2޲Ẳ͖֌Wȏ]ߓ_ɂ"ʐMJ"Ƃĉ
	  //- ꓾܂!!!B
	  if ( ((can_isp_rx_buffer[0]==NNB)||(can_isp_rx_buffer[0]==0xFF))
		 && (can_isp_rx_msg.dlc==1) )
	  {
		if (can_communication_opened == FALSE)
		{
		  can_communication_opened = TRUE;
		  isp_select_memory = MEM_DEFAULT;
		  isp_select_page = PAGE_DEFAULT;
		}
		else
		{
		  can_communication_opened = FALSE;
		}
		//- ڰ
		can_isp_tx_msg.id.std = (base_isp_id + CAN_ID_SELECT_NODE);
		can_isp_tx_msg.dlc = 2;
		can_isp_tx_buffer[0] = BOOT_VERSION;
		can_isp_tx_buffer[1] = can_communication_opened;
		can_isp_send_frame();
	  }
	  break;

	//- ݊Jn(0x01) -----------------------------------------------
	case CAN_ID_PROG_START:
//$-1
//	  isp_prog_on_going = FALSE;				//- ݒ蒆̎Ԓ߈ُh~u
	  if (can_communication_opened)
	  {
		//- S -----------------------------------------------------
		if ( (can_isp_rx_buffer[0] == CAN_FULL_ERASE_1) && \
			 (can_isp_rx_buffer[1] == CAN_FULL_ERASE_2) && \
			 (can_isp_rx_buffer[2] == CAN_FULL_ERASE_3)    )
		{
		  if (isp_memory_erase() == FALSE)
		  {
			can_isp_send_error_frame(); break;	//- case ...o
		  }
		}
		//- ݊Jn ----------------------------------------------
		else if (can_isp_rx_buffer[0] == CAN_INIT_PROG)
		{
		  isp_address_range   ( ( (((U16)can_isp_rx_buffer[1])<<8) | ((U16)can_isp_rx_buffer[2]) ) ,  \
								( (((U16)can_isp_rx_buffer[3])<<8) | ((U16)can_isp_rx_buffer[4]) ) ) ;
		  loc_buf_index = 0;
		  isp_prog_on_going = TRUE;
		  //- 򏑂݂ɎgpʒuwqƗʂۑ
		  isp_start_address_copy = isp_start_address;
		  isp_number_of_bytes_copy = isp_number_of_bytes;
		}
		//- ݊Jnُ -----------------------------------
		else
		{
		  can_isp_send_error_frame(); break;	//- case ...o
		}
		//- ڰ
		can_isp_tx_msg.id.std = (base_isp_id + CAN_ID_PROG_START);
		can_isp_tx_buffer[0] = COMMAND_OK;
		can_isp_tx_msg.dlc = 1;
		if(isp_prog_on_going == TRUE)
		{
		  can_isp_tx_msg.dlc = 0;
		}
		can_isp_send_frame();
	  }
	  break;

	//- ް (0x02) ------------------------------------------------
	case CAN_ID_PROG_DATA:
	  if (can_communication_opened)
	  {
		if ( isp_prog_on_going == TRUE )
		{
		  //- 򏑂 ------------------------------------------
		  for (i=0; i<can_isp_rx_msg.dlc; i++)
		  {
			local_buffer[loc_buf_index] = can_isp_rx_buffer[i];
			loc_buf_index++;
			u8_temp = 0x00;
		  }
		  if ( (loc_buf_index > (BUFFER_SIZE-0x08)) || (loc_buf_index == isp_number_of_bytes) )
		  {
			u8_temp = isp_prog_block(local_buffer, loc_buf_index);
			loc_buf_index = 0;
		  }
		  //- ڰ
		  can_isp_tx_msg.id.std = (base_isp_id + CAN_ID_PROG_DATA);
		  can_isp_tx_msg.dlc = 1;
		  if (u8_temp == 0x00)
		  {
			can_isp_tx_buffer[0] = OK_NEW_DATA;
		  }
		  else if (u8_temp == 0x01)
		  {
			can_isp_tx_buffer[0] = OK_END_OF_DATA;
			isp_prog_on_going = FALSE;
			//- ʒuwqƗʂ
			isp_start_address = isp_start_address_copy;
			isp_number_of_bytes = isp_number_of_bytes_copy;

		  }
		  else	//- u8_temp == 0xFF, ُ(: SSB)
		  {
			isp_prog_on_going = FALSE;
			can_isp_send_error_frame(); break;	//- case ...o
			//- : ʒuwqƗʂ͉񕜂܂B
		  }
		  can_isp_send_frame();
		}
		//- 򏑂ݎُ -----------------------------------
		else
		{
		  can_isp_send_error_frame();
		}
	  }
	  break;

	//- ްǂݍ(\) (0x03) ----------------------------------------------------
	case CAN_ID_DISPLAY_DATA:
	  isp_prog_on_going = FALSE;					//- ݒ蒆̎Ԓ߈ُh~u
	  if (can_communication_opened)
	  {
		//- ڰя
		can_isp_tx_msg.id.std = (base_isp_id + CAN_ID_DISPLAY_DATA);
		can_isp_tx_msg.dlc = 0;
		isp_address_range   ( ( (((U16)can_isp_rx_buffer[1])<<8) | ((U16)can_isp_rx_buffer[2]) ) ,  \
							  ( (((U16)can_isp_rx_buffer[3])<<8) | ((U16)can_isp_rx_buffer[4]) ) ) ;
		//- ʒuwqƗʂۑ
		isp_start_address_copy = isp_start_address;
		isp_number_of_bytes_copy = isp_number_of_bytes;
		//- ްǂݍ ------------------------------------------------------
		if (can_isp_rx_buffer[0] == CAN_READ_DATA)
		{
		  can_isp_tx_msg.dlc = 8;					//- 
		  while (1)
		  {
			//- i["can_isp_tx_buffer"gp
			u8_temp = isp_read_block(can_isp_tx_buffer,8);
			if (u8_temp == 0x00)
			{
			  can_isp_send_frame();					//- Ԃ̉
			}
			else if  (u8_temp == 0x01)
			{
			  can_isp_tx_msg.dlc = isp_number_of_bytes;
			  can_isp_send_frame();					//- Ō̉
			  break;								//- while ...o
			}
			else		//- u8_temp == 0xFF, ُ(: SSB)
			{
			  can_isp_send_error_frame(); break;	//- while ...o
			}
		  }
		}
		//- 󔒌 ----------------------------------------------------
		else if (can_isp_rx_buffer[0] == CAN_BLANK_CHECK)
		{
		  if ( isp_blank_check() == FALSE )
		  {
			//- ŏ̖󔒱ڽM̏
			can_isp_tx_msg.dlc = 2;
			can_isp_tx_buffer[0] = (U8)(isp_start_address >>8);
			can_isp_tx_buffer[1] = (U8)(isp_start_address);
		  }
		  //- ڰт܂͍ŏ̖󔒱ڽM
		  can_isp_send_frame();
		}
		//- ްǂݍ(\)ُ ----------------------------------------
		else
		{
		  can_isp_send_error_frame(); break;		//- case ...o
		}
		//- ʒuwqƗʂ
		isp_start_address = isp_start_address_copy;
		isp_number_of_bytes = isp_number_of_bytes_copy;
	  }
	  break;

	//- pJn (0x04) -----------------------------------------------
	case CAN_ID_START_APPLI:
//$-2
//	  isp_prog_on_going = FALSE;				//- ݒ蒆̎Ԓ߈ُh~u
	  if (can_communication_opened)
	  {
		if (can_isp_rx_buffer[0] == CAN_START_APPLI)
		{
		  //- ʰ޳ ؾ -----------------------------------------------------
		  if (can_isp_rx_buffer[1] == CAN_RESET_APPLI)
		  {
			// ް ۰ނ甲oʰ޳ ؾ
			Hard_reset();						// config.hɲݸٰނat90canxx_drv.h܂atmegaxxm1c1_drv.hQ
		  }
		  //- p֕@ ------------------------------------------
		  else if (can_isp_rx_buffer[1] == CAN_JUMP_APPLI)
		  {
			isp_jump_to( (((U16)can_isp_rx_buffer[2])<<8) | ((U16)can_isp_rx_buffer[3]) );
		  }
		  //- ؾĂ܂͕Ȃł̉pJnُ --------------
		  else { can_isp_send_error_frame(); break; }	//- case ...o
		}
		//- pJnُ -----------------------------------
		else { can_isp_send_error_frame(); break; }		//- case ...o
	  }
	  break;

	//-  ߰ޑI (0x06)    -------------------------------------------
	case CAN_ID_SELECT_MEM_PAGE:
	  isp_prog_on_going = FALSE;				//- ݒ蒆̎Ԓ߈ُh~u
	  if (can_communication_opened)
	  {
		//- Ȃ ------------------------------------------------------
		if      (can_isp_rx_buffer[0] == CAN_NO_ACTION);	//- Ȃ

		//- ؑÎ ---------------------------------------------
		else if (can_isp_rx_buffer[0] == CAN_SEL_MEM)
		{
		  isp_set_memory(can_isp_rx_buffer[1]);
		}
		//- ߰ޑÎ -----------------------------------------------
		else if (can_isp_rx_buffer[0] == CAN_SEL_PAGE)
		{
		  isp_set_page(can_isp_rx_buffer[2]);
		}
		//- ؂߰ނ̑I -----------------------------------------
		else if (can_isp_rx_buffer[0] == CAN_SEL_MEM_N_PAGE)
		{
		  isp_set_memory(can_isp_rx_buffer[1]);
		  isp_set_page(can_isp_rx_buffer[2]);
		}
		//-  ߰ޑIُ ----------------------------------
		else
		{
		  can_isp_send_error_frame(); break;	//- case ...o
		}
		//- ڰ
		can_isp_tx_msg.id.std = (base_isp_id + CAN_ID_SELECT_MEM_PAGE);
		can_isp_tx_msg.dlc = 1;
		can_isp_tx_buffer[0] = COMMAND_OK;
		can_isp_send_frame();
	  }
	  break;

	//- ̑ ----------------------------------------------------------------
	default:
	  break;
  }   // switch ((can_isp_rx...
  return(1);
}

//------------------------------------------------------------------------------
//  @fn can_isp_send_error_frame
//!
//! ̊֐CAN ISPKŋKُڰт𑗂܂B
//!
//! @warning	Ȃ
//!
//! @param	Ȃ
//!
//! @return
//!
//------------------------------------------------------------------------------
void can_isp_send_error_frame(void)
{
  can_isp_tx_msg.id.std = (base_isp_id + CAN_ID_ERROR);
  can_isp_tx_buffer[0] = 0x00;
  can_isp_tx_msg.dlc = 1;
  can_isp_send_frame();
}

//------------------------------------------------------------------------------
//  @fn can_isp_send_frame
//!
//! ̊֐CAN ISPKڰт𑗂܂B
//!
//! @warning	Ȃ
//!
//! @param	Ȃ
//!
//! @return
//!
//------------------------------------------------------------------------------
void can_isp_send_frame(void)
{
  //- M(Ɏ󂯓!!!)
  can_cmd(&can_isp_tx_msg);
  //- Mҋ@
  while(can_get_status(&can_isp_tx_msg) == CAN_STATUS_NOT_COMPLETED);
}
