//******************************************************************************
//! @file $RCSfile: flash_boot_drv.h,v $
//!
//! Copyright (c) 2009 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txtǂłB
//!
//! @brief ̊֐AT90CAN128/64/32޲ׯ  p̒ʌ^ϸۂ
//!		   ݂܂B
//!
//! ̧وȉŊmFĂ܂B
//! - AVRStudio 4.15.623,
//! - IAR AVRpC/C++߲ 5.20.1 (5.20.1.50092)
//!
//! @version $Revision: 3.00 $ $Name: jtellier $
//!
//! @todo
//! @bug
//******************************************************************************

#ifndef _FLASH_BOOT_DRV_H_
#define _FLASH_BOOT_DRV_H_

//_____ ݸٰ ________________________________________________________________
#include <intrinsics.h>

//_____ ` ___________________________________________________________________
#define _FLASH_TYPE_		__flash
#define _FARFLASH_TYPE_		__farflash

#define FLASH_BYTE_AT		*(U8 _FLASH_TYPE_*)
#define FARFLASH_BYTE_AT	*(U8 _FARFLASH_TYPE_*)
#define FLASH_WORD_AT		*(U16 _FLASH_TYPE_*)
#define FARFLASH_WORD_AT	*(U16 _FARFLASH_TYPE_*)
#define SRAM_BYTE_AT		*(U8*)

#define FLASH_BLANK_WORD	0xFFFF

//_____ ϸ ____________________________________________________________________

//--- {Iׯ֊֐
#define Flash_fill_temp_buffer(addr, data_w)	{ _SPM_FILLTEMP((void _FLASH_TYPE_*) addr, data_w); }
#define Flash_page_write(page_addr)				{ _SPM_PAGEWRITE((void _FLASH_TYPE_*) page_addr)  ; }
#define Flash_page_erase(page_addr)				{ _SPM_ERASE((void _FLASH_TYPE_*) page_addr)      ; }

  //--- ׯ֐
#define Stdflash_rd_byte(addr_byte)				( FLASH_BYTE_AT(addr_byte) )
#define Stdflash_rd_word(addr_word)				( FLASH_WORD_AT(addr_word) )
#define Farflash_rd_byte(addr_byte)				( FARFLASH_BYTE_AT(addr_byte) )
#define Farflash_rd_word(addr_word)				( FARFLASH_WORD_AT(addr_word) )

#define Flash_rww_section_enable				{ __DataToR0ByteToSPMCR_SPM(0x00, 0x11) ; }
#define Flash_prog_completed					{ while (SPMCSR & (1<<SPMEN)); }

//--- SRAM֐
#define Sram_rd_byte(addr_byte)					( SRAM_BYTE_AT(addr_byte) )

//_____ 錾 ___________________________________________________________________

//------------------------------------------------------------------------------
//  @fn flash_fill_temp_buffer
//!
//! ̊֐ׯꎞɏՕɌ̐ݒ܂B
//!
//! @warning	Ȃ
//!
//! @param:	addr	16ޯČ߂ׯ ̱ؓڽ
//!			word	ׯ ؂ɏ߂̌̒l
//!
//! @return	Ȃ
extern  void flash_fill_temp_buffer(U16 addr, U16 word);

//------------------------------------------------------------------------------
//  @fn flash_page_write
//!
//! ̊֐ׯꎞɏՕeׯ ߰ނ݂̏܂B
//!
//! @warning:	(:RAMPZڼ޽̐ݒ܂͉)O64K߰ސݒ肪sȂ
//!				Ȃ܂B
//!
//! @param:	page_addr	߂߰ ڽ
//!
//! @return	Ȃ
extern  void flash_page_write(U16 page_addr);

//------------------------------------------------------------------------------
//  @fn flash_page_erase
//!
//! ̊֐ׯ ߰ނ̏܂B
//!
//! @warning:	(:RAMPZڼ޽̐ݒ܂͉)O64K߰ސݒ肪sȂ
//!				Ȃ܂B
//!
//! @param:	page_addr	߰ ڽ
//!
//! @return	Ȃ
extern void flash_page_erase(U16 page_addr);

//******************************************************************************

#endif // _FLASH_BOOT_DRV_H_
